#!/usr/bin/perl

#This script indents a treebank file
#usage: cat  FILE |indent.pl

while(<>){
    s/^\s+$//;
    if(/^\s*\</){
	#chomp;
	print ;
    }else{
	if($start==0){     #start of sentence
	    $start=1;
	}
	chomp;
	$sentence.=$_;

	if(evenbrack($sentence)){   #end of sentence
	    indent($sentence);
	    print "\n";
	    #reset variables
	    $start=0;
	    $sentence="";

	}
    }
}


sub indent {
    my ($thesentence) = @_;
    undef @path;
    #undef %idconstituents;  #key=id, value=constituents
    #undef %idpairs; #key=id, value = pid
    undef %idlabels;

    $id=1;
    $thesentence =~ s/^\s*//;
    $thesentence =~ s/^\(\s*\(/\( \(/; #top level node

    $thesentence =~ s/\s+/ /g;
    $thesentence =~ s/\)\s*\(/\)\(/g;
    for(my $i=0; $i<length($thesentence); $i++){
	print substr($thesentence,$i,1);
	if(substr($thesentence,$i,1) eq "("){
	    push(@path, ($id));
	    $thisconstituent=substr($thesentence,$i,1);
	    my $j=$i+1;
	    while(!evenbrack($thisconstituent)){
		$thisconstituent.=substr($thesentence, $j,1);
		$j++;
	    }
	    if($id == 1){
		$pid=0;
	    }else{
		$pid = $path[$#path-1];
	    }
	    #$idconstituents{$id} = $thisconstituent;
	    #$idpairs{$id} =  $pid;
	    $thisconstituent =~/^\(([^\t\r\n\f() ]+)\s+/;
	    $idlabels{$id} = $1;
	    $id++;
	}elsif(substr($thesentence,$i,1) eq ")"){
	    #print "@path\n";
	    pop(@path);
	    my $nextpos = $i+1;
	    if(substr($thesentence,$nextpos,1) eq "("){
		#this assumes the next character is (, very brittle
		#print "testtestteeeeeeeeeeeee";
		#next line, indent
		print "\n";
		my $indentlen=0;
		for (my $m=0; $m<=$#path; $m++){
		    $indentlen += length($idlabels{$path[$m]});
		    $indentlen += 2;   #1 bracket + 1 space
		}
		#$indentlen--; #no space after top left bracket
		printnspaces($indentlen);
	    }

	}

    }
}


sub printnspaces{
    my ($n) =@_;
    print "\t" x ($n/8), ' ' x ($n%8); 
}



sub finddaughters {
   #given an ID, find all the immediate daughters of this constituent
    my ($pid) = @_;
    my @daughtersid;
    foreach my $key2 (sort {$a <=> $b} keys %idpairs){
	#print "daughter id: $key2\n";
	if($idpairs{$key2} == $pid){
	    push (@daughtersid, ($key2));
	}
    }
    #print "daughters: ", @daughtersid,"\n";
    return @daughtersid;
}				


sub evenbrack{
    ($line)=@_;
    if($line=~s/\(/\(/g == $line=~s/\)/\)/g){return 1;}
    else{return 0;}
}







